

#import <objc/Object.h>
#import <sys/time.h>
#import "graphics.h"


#define NX_PRINTKEYMAXLEN (1024)		// Max num of chars in key.

#define NX_PRINTERTABLEOK	(0)
#define NX_PRINTERTABLENOTFOUND	(1)
#define NX_PRINTERTABLEERROR	(2)


@interface NXPrinter:Object
{
    const char	*printerName;
    const char	*hostName;
    const char	*domainName;
    const char	*printerType;
    BOOL	_ignore;
    BOOL	_valid;
    int		_creationNum;
    void	*_nodes;
    struct timeval _previousValid;
    long	_niInstance;
    void	*_priv;
    void	*reserved[10];
}

+ (NXPrinter *)newForName:(const char *)name;
+ (NXPrinter *)newForName:(const char *)name host:(const char *)host;
+ (NXPrinter *)newForName:(const char *)name host:(const char *)host
                   domain:(const char *)domain includeUnavailable:(BOOL)flag;
+ (NXPrinter *)newForType:(const char *)type;
+ (char **)printerTypes:(BOOL)types custom:(BOOL)custom;

- (const char *)name;
- (const char *)domain;
- (const char *)host;
- (const char *)type;
- (const char *)note;
- (BOOL)isColor;
- (BOOL)acceptsBinary;
- (BOOL)isOutputStackInReverseOrder;
- (NXSize)pageSizeForPaper:(const char *)paperName;
- (NXRect)imageRectForPaper:(const char *)paperName;
- (int)languageLevel;
- (BOOL)isFontAvailable:(const char *)faceName;
- (BOOL)isReallyAPrinter;
- (int)statusForTable:(const char *)table;
- (BOOL)isValid;

- (BOOL)isKey:(const char *)key inTable:(const char *)table;
- (const char *)stringForKey:(const char *)key inTable:(const char *)table;
- (NXSize)sizeForKey:(const char *)key inTable:(const char *)table;
- (NXRect)rectForKey:(const char *)key inTable:(const char *)table;
- (int)intForKey:(const char *)key inTable:(const char *)table;
- (float)floatForKey:(const char *)key inTable:(const char *)table;
- (BOOL)booleanForKey:(const char *)key inTable:(const char *)table;
- (void *)dataForKey:(const char *)key inTable:(const char *)table length:(int *)lenp;
- (const char **)stringListForKey:(const char *)key inTable:(const char *)table;

- init;
- free;


@end
